#pragma once
namespace YoggieEngine {
	struct IdentifierComponent {
		std::string name;
	};

	struct TransformComponent {
		glm::vec3 Position = glm::vec3(0.0f);
		glm::vec3 Rotation = glm::vec3(0.0f);
		glm::vec3 Scale = glm::vec3(1.0f);


		glm::mat4 GetTransformMatrix() {
			glm::mat4 result = glm::mat4(1.0f);
			glm::mat4 rotate = glm::rotate(glm::mat4(1.0f), Rotation.x, glm::vec3(1.f, 0.f, 0.f));
			rotate *= glm::rotate(glm::mat4(1.0f), Rotation.y, glm::vec3(0.f, 1.f, 0.f));
			rotate *= glm::rotate(glm::mat4(1.0f), Rotation.z, glm::vec3(0.f, 0.f, 1.f));


			result =  rotate  * glm::scale(glm::mat4(1.0f), Scale) *   glm::translate(glm::mat4(1.0f), Position) ;

			return result;
		}

	};

	struct LightComponent {
		glm::vec3 Color = glm::vec3(1.0f, .5f, .5f);
	};


	struct CameraComponent {
		glm::vec3 Position = glm::vec3(0);
		glm::vec3 Rotation = glm::vec3(0);
		float Zoom ;
	};


	struct ScriptComponent {
		std::string file; // TODO : replace with proper properties
	};

	struct Render3DComponent {
		unsigned int VAO = 0;
		unsigned int IBO = 0;
		Mesh mesh;
		// TODO: becomes a material 
		glm::vec3 color;
		Shader shader;

		Render3DComponent()
			: shader(Shader("build/Debug/Shaders/forward/geometry.vert", "build/Debug/Shaders/forward/geometry.frag")),
			  color(glm::vec3(1.0f, 0.0f, 0.0f))
		{ 
		}
	};

	struct Render2DComponent {
		glm::vec3 Colour;
		
	};
};